<script setup lang="ts">
import { computed } from 'vue';
import { useApplicationStore } from '../stores/application';
import { Alert } from '../entities';

const props = defineProps<{
  error?: string;
}>();

const applicationStore = useApplicationStore();

const alerts = computed<Alert[]>(() => {
  let emittedAlert: Alert | undefined = undefined;

  switch (props.error) {
    case undefined:
      emittedAlert = undefined;
      break;
    case 'network':
      emittedAlert = {
        type: 'error',
        short: 'Netzwerkfehler',
        uniqueType: 'network',
        description:
          'Bitte später erneut versuchen. Sollte das Problem bestehen bleiben, kontaktiere bitte das IT-Team.',
      };
      break;
    case 'forbidden':
      emittedAlert = {
        type: 'error',
        short: 'Zugriffsfehler',
        uniqueType: 'forbidden',
        description:
          'Zugriff nicht erlaubt. Sollte dies inkorrekt sein, kontaktiere bitte das IT-Team.',
      };
      break;
    case 'unexpected':
      emittedAlert = {
        type: 'error',
        short: 'Unerwartete Anwort',
        uniqueType: 'unexpected',
        description:
          'Bitte später erneut versuchen. Sollte das Problem bestehen bleiben, kontaktiere bitte das IT-Team.',
      };
      break;
    default:
      emittedAlert = {
        type: 'error',
        short: 'Unbekannter Fehler',
        uniqueType: 'unknown',
        description:
          'Bitte später erneut versuchen. Sollte das Problem bestehen bleiben, kontaktiere bitte das IT-Team.',
      };
      break;
  }

  const result = applicationStore.getAlerts;
  return emittedAlert != undefined ? result.concat([emittedAlert]) : result;
});
</script>

<template>
  <div>
    <div v-for="alert in alerts">
      <v-alert :type="alert.type" prominent>
        {{ alert.short }}<br /><span v-if="typeof alert.description === 'string'">{{
          alert.description
        }}</span>
        <span v-else>
          <ul v-for="message in alert.description">
            <li>{{ message }}</li>
          </ul>
        </span>
      </v-alert>
    </div>
  </div>
</template>
